#ifndef NETWIN_H
#define NETWIN_H

#include <QtGui/QtGui>
#include "codenet.h"
#include "netdrive.h"

class NetWin : public QDialog
{
  Q_OBJECT
  
public:
  NetWin(QWidget *parent=0);
  ~NetWin();

  void runProgram(quint16 addr,const QByteArray &data);
  void shareFiles(const CBMFileList &files);
  
  void saveSettings();
  void loadSettings();

public slots:
  void stopNet();
  
protected slots:
  void logMessage(const QString &msg);
  void reportInPacket(int size);
  void reportOutPacket(int size);

protected:
  QTextEdit *m_logView;
  QLabel    *m_packetsInLabel;
  QLabel    *m_packetsOutLabel;
  QToolButton *m_stopButton;
  
  int m_packetsIn;
  int m_packetsOut;
  int m_packetsInSize;
  int m_packetsOutSize;
  
  CodeNetService *m_codeNet;
  NetDriveService *m_netDrive;
  
  void logService(NetService *service);
  void updateCounters();
  void resetCounters();

  void startCodeNet();
  void startNetDrive();
};

#endif
